import { AfterViewInit, Component, ElementRef, ViewChild } from '@angular/core';

import WebViewer, { WebViewerInstance, Core } from '@pdftron/webviewer';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss']
})

export class AppComponent implements AfterViewInit {
  @ViewChild('viewer', { static: false }) viewer: any;

  title = 'redacttest';
  
  ngAfterViewInit(): void {
    WebViewer(
      {
        path: './webviewer',
        fullAPI: true,
        enableRedaction: true,
        licenseKey: '',
        loadAsPDF: true
      },
      this.viewer.nativeElement
    ).then(async (instance: WebViewerInstance) => {
    
      let doc: Core.PDFNet.PDFDoc | null = null;
      const { PDFNet } = instance.Core;
      await PDFNet.initialize();
      
      const buf2 = await (<any>(
        instance.Core
      )).officeToPDFBuffer(
        'https://pdftron.s3.amazonaws.com/downloads/pl/report.docx',
        {extension: 'docx'}
      );

      doc = await PDFNet.PDFDoc.createFromBuffer(buf2);
      instance.UI.loadDocument(doc, {
        filename: 'test.docx',
      });            
    });
  }
}
